﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.Controls;
using Telerik.Windows;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            ObservableCollection<Item> items = new ObservableCollection<Item>();

            var sets = new Item()
            {
                Items = new ObservableCollection<Item>()
                {
                    new Item{Title = "Set 1"},
                    new Item{Title = "Set 2"},
                    new Item{Title = "Set 3"},
                    new Item{Title = "Set 4"}
                },

                Title = "Sets"
            };

            var reports = new Item()
            {
                Items = new ObservableCollection<Item>()
                {
                    new Item{Title = "Report 1"},
                    new Item{Title = "Report 2"},
                    new Item{Title = "Report 3"},
                    new Item{Title = "Report 4"}
                },

                Title = "Reports"
            };

            items.Add(sets);
            items.Add(reports);

            this.DataContext = items;

            this.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(DragQuery_CanDrop), true);

        }

        public FrameworkElement EffectiveDestination { get; set; }

        private void DragQuery_CanDrop(object sender, DragDropQueryEventArgs e)
        {
            var treeViewItem = e.Options.Destination as RadTreeViewItem;
            if (treeViewItem != null)
            {
                if (((Item)treeViewItem.Item).Title.Contains("Set"))
                {
                    if (treeViewItem.DropPosition == DropPosition.Inside)
                    {
                        e.QueryResult = true;
                    }
                    else
                    {
                        e.QueryResult = false;
                    }
                }
                else if (((Item)treeViewItem.Item).Title.Contains("Report"))
                {
                    if (treeViewItem.ParentItem != null && ((Item)treeViewItem.ParentItem.Item).Title.Contains("Set"))
                    {
                        e.Options.Destination = treeViewItem.ParentItem;
                        treeViewItem.DropPosition = DropPosition.Inside;

                        e.QueryResult = true;
                    }
                    else
                    {
                        e.QueryResult = false;
                    }
                }
                else
                {
                    e.QueryResult = false;
                }
            }
            else
            {
                e.QueryResult = false;
            }
            e.Handled = true;
        }
    }

    public class Item
    {
        public ObservableCollection<Item> Items { get; set; }
        public string Title { get; set; }
    }
}
